#ifndef __LIBTCP_H__
#define __LIBTCP_H__

#include "source4/dns_server/dns_server.h"
#include "source4/dns_server/dnsserver_common.h"
#include "lib/tsocket/tsocket.h"

/** dns tcp definitions **/
struct tsocket_address;

struct dns_socket {
	struct dns_server *dns;
	struct tsocket_address *local_address;	
};

struct dns_tcp_request_state {
	struct tevent_context *ev;
	struct tstream_context *tstream;
	size_t query_len;
	uint32_t *reply;
	size_t reply_len;
};

/* dns tcp request */
struct tevent_req *tstream_writev_send(TALLOC_CTX *mem_ctx,
				       struct tevent_context *ev,
				       struct tstream_context *stream,
				       const struct iovec *vector,
				       size_t count);

/* dns tcp response result */
int tstream_writev_recv(struct tevent_req *req,
			    int *perrno);



















#endif /*__LIBDNS_H__*/